View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0009329ParaViewFeaturepublic2009-07-28 20:152011-09-01 13:31
ReporterAlan Scott 
Assigned ToUtkarsh Ayachit 
PrioritynormalSeverityminorReproducibilityalways
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version 
Target Version3.8.1Fixed in Version3.12 
Summary0009329: Add ability to reverse the endpoint of Glyph arrows
DescriptionWe need to add a checkbox to the Glyph filter, allowing an arrow to point AT a point, rather than FROM a point. For instance, if I have a force on a plate, and want to show this vector with arrows, I don't want the arrow to start at the surface of the plate and go INTO the plate - I want the arrow to start ABOVE the plate and have the arrow point AT the plate. Clear as mud? Ask me for a better description by phone. This option should be user selectable.

Current behavior is correct for fluid flow folks, what I am asking is correct for mechanical design folks.

Very nice to have in for 3.6.2, if it is easy.
TagsNo tags attached.
Project
Topic Name
Type
Attached Files? file icon InverseArrowGlyphs.cpd [^] (9,713 bytes) 2009-07-29 10:41
png file icon currentGlyph.png [^] (26,088 bytes) 2009-07-31 20:18


png file icon wantedGlyph.png [^] (30,154 bytes) 2009-07-31 20:19

- Relationships Relation Graph ] Dependency Graph ]

-  Notes
(0017004)
Ken Moreland (manager)
2009-07-29 10:45

There is a workaround to this. Create an Arrow source. Then translate it -1 in the x direction. Then use the Glyph With Custom Source filter to apply the translated arrow as glyphs on the data.

Attached is a custom filter that implements this internally (InverseArrowGlyphs.cpd). To use it, go to Tools -> Manage Custom Filters. Click Import and load the attached file. Then, use the added Inverse Arrow Glyph filter much as you would the regular glyph filter.

So the next question is how common is this operation? Is this something one guy has to do once a year or is it something a group of people have to do on a daily basis. It makes a big difference on whether the Glyph filter itself needs to change.
(0017012)
Alan Scott (manager)
2009-07-29 15:26

The workaround does work, but I couldn't get the attached cpd file to work. Anyway, lets try to get this fixed for 3.8.

This is an operation that will occur by anyone doing forces on objects, such as mechanical design folks. Thus, I believe this will occur frequently, and thus should be put into the Glyph filter.
(0017041)
Utkarsh Ayachit (administrator)
2009-07-31 14:49

Added ability to invert arrows used in glyphs. On the glyph filter's panel, where it shows the properties for the arrows, a new checkbox named "Invert" is added, when checked results in inverted arrows. Similar property is added to the Normal Glyphs filter as well.

/cvsroot/ParaView3/ParaView3/VTK/Graphics/vtkArrowSource.h,v <-- VTK/Graphics/vtkArrowSource.h
new revision: 1.11; previous revision: 1.10
/cvsroot/ParaView3/ParaView3/VTK/Graphics/vtkArrowSource.cxx,v <-- VTK/Graphics/vtkArrowSource.cxx
new revision: 1.8; previous revision: 1.7
/cvsroot/ParaView3/ParaView3/Servers/ServerManager/Resources/sources.xml,v <-- Servers/ServerManager/Resources/sources.xml
new revision: 1.99; previous revision: 1.98
/cvsroot/ParaView3/ParaView3/Servers/ServerManager/Resources/filters.xml,v <-- Servers/ServerManager/Resources/filters.xml
new revision: 1.362; previous revision: 1.361
(0017047)
Alan Scott (manager)
2009-07-31 20:17

Cool feature, but not what I need. I also wasn't very clear. What I want is as follows:
* Lets say I have a vector field entry Vect, at a point Pnt.
* I glyph Vect with arrows. Now, at the TAIL of the arrow is point Pnt, on the surface of the object. The arrow has a Length in the direction of Vect, heading away from my surface.
* What I need is to now have the arrow translated in direction -Vect by length Length. Now the TIP of the arrow is on Pnt, and the arrow is pointing TOWARDS Pnt.

See the attached screen shots of the force of soil on a buried pipe.
CurrentScreenshot.png is what we currently get.
wantedScreenshot.png, is what is desired.
(0018721)
zhangyuanchao (reporter)
2009-12-08 09:49

Hi, wascott, have you solved your problem to change the direction of the arrow point by point? I am currently faced with the same problem and did not know how to proceed. For arrows pointing inside a closed surface, I want to pull out the arrows, it is the same as changing the direction of the arrow, and let the head of the arrow locate at the vertex. While for arrows pointing outside the mesh, I want to keep the arrows pointing outward sticking to the vertex.

Could you help me?

Thanks.
(0021351)
Utkarsh Ayachit (administrator)
2010-07-12 10:08

We can come up with a solution that addresses this issue as well:

http://paraview.uservoice.com/forums/11350-general/suggestions/309509-orient-cylinder-glyp-direction-using-vector?ref=title [^]
(0021352)
Utkarsh Ayachit (administrator)
2010-07-12 10:56

VTK-Commit
-----------------
commit 0a3b44fbb6f0afd629e210f971dff1d226899b5f
Author: Utkarsh Ayachit <utkarsh.ayachit@kitware.com>
Date: Mon Jul 12 10:54:37 2010 -0400

    Fixed BUG 0009329. Added ability to specify a transform for the glyphs.


ParaView Commit
------------------
commit b44f5013e45df0f58440e1043b2bd557532134e9
Author: Utkarsh Ayachit <utkarsh.ayachit@kitware.com>
Date: Mon Jul 12 10:53:21 2010 -0400

    Added ability to specify a transform for the source geometry.
    
    This is an easy solution to address BUG 0009329.
(0021353)
Utkarsh Ayachit (administrator)
2010-07-12 10:59

commit 8a79d7793e4aeecfe49c37d3104f5445a1666059
Author: Utkarsh Ayachit <utkarsh.ayachit@kitware.com>
Date: Mon Jul 12 10:58:38 2010 -0400

    Renaming "Transform" to "Glyph Transform"
(0021358)
Utkarsh Ayachit (administrator)
2010-07-12 12:12

On the "Glyph" properties panel, there's are now a collection of widgets that allow the user to specify GlyphTransform to transform the glyph. For your use case, simply set the "Translate" to (-1, 0, 0).

Also added a test in the following commit.

commit 7fa44850d108ce6b17f8c24b8390c2224f24dd48
Author: Utkarsh Ayachit <utkarsh.ayachit@kitware.com>
Date: Mon Jul 12 12:10:07 2010 -0400

    Enhaned test to include glyph transform.
(0021360)
Utkarsh Ayachit (administrator)
2010-07-12 13:48

commit ce5c5adb03df6a8b3ff6c4d21c2cbdfab067ead8
Author: Utkarsh Ayachit <utkarsh.ayachit@kitware.com>
Date: Mon Jul 12 13:38:40 2010 -0400

    Moved Transform2 proxy to extended_sources so it's accessible from Python.
    
    Fixes python tracing issues with Glyph filter after fix for BUG 0009329.
(0021364)
Alan Scott (manager)
2010-07-12 19:32

Tested local server, Windows, trunk.

Tested with a sphere source. I could not figure out how to test with data that has time displacement data.

- Issue History
Date Modified Username Field Change
2009-07-28 20:15 Alan Scott New Issue
2009-07-29 10:41 Ken Moreland File Added: InverseArrowGlyphs.cpd
2009-07-29 10:45 Ken Moreland Note Added: 0017004
2009-07-29 15:26 Alan Scott Note Added: 0017012
2009-07-29 15:27 Alan Scott Target Version 3.6.2 => 3.8
2009-07-31 14:49 Utkarsh Ayachit Note Added: 0017041
2009-07-31 14:49 Utkarsh Ayachit Status backlog => @80@
2009-07-31 14:49 Utkarsh Ayachit Fixed in Version => 3.8
2009-07-31 14:49 Utkarsh Ayachit Resolution open => fixed
2009-07-31 14:49 Utkarsh Ayachit Assigned To => Utkarsh Ayachit
2009-07-31 20:17 Alan Scott Note Added: 0017047
2009-07-31 20:17 Alan Scott Status @80@ => @20@
2009-07-31 20:17 Alan Scott Resolution fixed => reopened
2009-07-31 20:18 Alan Scott File Added: currentGlyph.png
2009-07-31 20:19 Alan Scott File Added: wantedGlyph.png
2009-12-08 09:49 zhangyuanchao Note Added: 0018721
2010-04-16 02:01 Utkarsh Ayachit Status @20@ => tabled
2010-04-16 02:01 Utkarsh Ayachit Fixed in Version 3.8 =>
2010-04-16 02:01 Utkarsh Ayachit Target Version 3.8 => 3.8.2
2010-06-15 09:44 Utkarsh Ayachit Target Version 3.8.2 => 3.8.1
2010-07-12 10:08 Utkarsh Ayachit Note Added: 0021351
2010-07-12 10:56 Utkarsh Ayachit Note Added: 0021352
2010-07-12 10:59 Utkarsh Ayachit Note Added: 0021353
2010-07-12 12:12 Utkarsh Ayachit Note Added: 0021358
2010-07-12 12:12 Utkarsh Ayachit Status tabled => @80@
2010-07-12 12:12 Utkarsh Ayachit Fixed in Version => Development
2010-07-12 12:12 Utkarsh Ayachit Resolution reopened => fixed
2010-07-12 13:48 Utkarsh Ayachit Note Added: 0021360
2010-07-12 19:32 Alan Scott Note Added: 0021364
2010-07-12 19:32 Alan Scott Status @80@ => closed
2011-01-13 17:00 Source_changeset_attached => VTK master a2bd8391
2011-01-13 17:00 Source_changeset_attached => VTK master 020ef709
2011-06-16 13:10 Zack Galbreath Category Feature Request => Feature
2011-09-01 13:31 Utkarsh Ayachit Fixed in Version Development => 3.12


Copyright © 2000 - 2017 MantisBT Team
Powered by Mantis Bugtracker